!mozi-koodo: EUC
! 直方６面体立体要素の有限要素プログラム tyokum.f で
! 5点載荷曲げ試験の梁を1/4解析で解かせる入力データを作るプログラム
!
!     
!  ___↓_______↓____
! △       △       △  の右半分、手前半分の1/4を解く。
!          --       --
!
!このプログラムを実行させると、mage5p.d というデータができあがるから
!tyokum<mage5p.d （ hogeにファイル出力するなら tyokum<mage5p.d>hoge ）
!と実行させればよい。
!
!06/11/27版
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!このプログラムは無保証です。                           
!このプログラムは改造／再配布して構いません。           
!但し、私的利用に留まらない場合は、もとのプログラムが   
!http://www.str.ce.akita-u.ac.jp/~gotou/programoj/      
!から取ってきたものと分かるように明示して下さい。       
!改造／再配布後も上記の条件を保持して下さい。           
!バグの報告は、                                         
!http://www.str.ce.akita-u.ac.jp/~gotou/png/meeru.png   
!にお願いします。                                       
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
        program mage5p
           implicit real*8 (a-h, o-z)
           dimension a(3,3),lkais(100),lryou(100)
!
!スカイラインの1次元配列のサイズは、同じ自由度数でも要素分割
!に依存するので、自由度数から一意には決められない。
!mage.f の要素分割のやり方だと、軸長（z軸）の分割数がxy断面
!の分割数に比べて多いとスパース部分が増える。
!仮にスパース部分が皆無だったとすると
!およそ自由度×自由度／２のサイズになるが、こんなサイズは想定外。
!取り敢えず、12000を最大節点数、その３倍を最大自由度数にしておく。
!具体的な要素分割例としては、(縦+1)×(横+1)×(軸長+1)が、
!(6+1)*(12+1)*(99+1)=9191,(20+1)*(20+1)*(20+1)=9261 など。
!mage.f で幅（半解析だから幅の半分）×高さ×軸長が
!1*(8〜20)*(50〜100)ぐらいの範囲のものを解く場合、有効数字３桁
!の収束解が得られる要素分割数は 6分割×10分割×100分割ぐらい。
!図心が節点上に来るようにするには高さ方向の分割数を偶数にする。
!幅（の半分）に対して桁高が10倍以上高い場合は、幅の分割数は
!1 でもいいぐらいかも。
!
!梁の断面の横の長さ:yoko, 縦の長さ:tate
            yoko=1.d0
            tate=2.d0
!梁の軸長：ziku
            ziku=20.d0
!断面横方向の要素分割数：nx
!断面縦方向の要素分割数：ny
!軸方向の要素分割数：nz
          write(*,*) '要素分割数を入力して下さい'
          write(*,*) '（横,縦,軸長の順にコンマ区切りで）'
          write(*,*) '(縦+1)×(横+1)×(軸長+1)<9400'
          write(*,*) '例えば、6,10,100 や 6,12,99 や 20,20,20 など'
          read(*,*) nx,ny,nz
!
!********** 境界条件 *************
!
!拘束箇所の数：kkasyo
!同じ節点を定義しなおした場合は、後から定義した方が有効
!一箇所目で定義した場所を二箇所目で定義しなおすこともできる
!
!単純支持端面(右端)の中立軸(y=0)が1箇所目
!梁中央対称面(xy面)が2箇所目
!梁中央対称面の中立軸(x軸)が3箇所目
!梁中央対称面の対称軸(y軸)が4〜4+ny箇所目
!梁縦断対称面(yz面)が4+ny+1〜4+ny+(ny+1)*nz箇所目
!梁中央対称面の原点が 4+ny+(ny+1)*nz+1箇所目
!単純支持端面のz軸点が 4+ny+(ny+1)*nz+2箇所目
            kkasyo=4+ny+(ny+1)*nz+2
!1箇所目の拘束箇所における拘束開始節点番号:kkais1
            kkais1=(nx+1)*(ny+1)*nz  ! 右端の面の1つ前の面までの節点数
     &              +(nx+1)*(ny/2) ! 断面の上端から中立軸手前までの節点数
     &              +1
!1箇所目の拘束箇所における拘束終了節点番号:kryou1
            kryou1=(nx+1)*(ny+1)*nz  ! 右端の面の1つ前の面までの節点数
     &              +(nx+1)*(ny/2) ! 断面の上端から中立軸手前までの節点数
     &              +(nx+1)
!tyoku.fでは拘束開始点から拘束終了点まで節点番号順に全て
!同じ拘束条件を与える。要素番号の順番は、最前面最上段左端の節点を
!1として、右(x)方向に進み、右端まできたらy方向へ1段下の段の左端から
!右へすすみ、真下の右端までいったら、z方向へ1面奥の面の左上から、
!また同じように1段づつ右へ進み、最下段の右端までいったら、もう一つ
!奥の面へと進んでいき、一番奥の面の最下段の右端が最終要素番号
!
!1箇所目の拘束箇所における拘束条件
!u,v,w 方向の変位をそれぞれ拘束するか開放するか(0/1)
            bu1=1.d0
            bv1=0.d0  !単純支持端中立軸のy方向変位のみ拘束
            bw1=1.d0
!2箇所目の拘束箇所における拘束開始節点番号:kkais2
            kkais2=1
!2箇所目の拘束箇所における拘束終了節点番号:kryou2
            kryou2=(nx+1)*(ny+1)
!2箇所目の拘束箇所における拘束条件
!まず、梁中央対称面のz方向変位のみをすべて拘束する
             bu2=1.d0
             bv2=1.d0
             bw2=0.d0
!でも、xy平面を移動できてしまうので、中立軸のy方向変位を拘束する
             kkais3=(nx+1)*(ny/2)+1  !3箇所目の拘束開始節点
             kryou3=kkais3+nx  !3箇所目の拘束終了節点
             bu3=1.d0
             bv3=0.d0
             bw3=0.d0
!あと、対称面(yz面)のx方向変位を拘束する必要があるが、これは、
!量が多いので下のデータ出力時にdo ループで直接 書く。
!
!
!*********** 載荷条件 ************
!
!載荷箇所の数：lkasyo
!載荷箇所は、同じ節点の荷重を後から定義しなおしても構わない。
!今回は、2要素の重なる節点を1箇所目、
!四隅の1要素だけの節点を2,3,4,5箇所目
!4要素の重なる節点を6箇所目として与える
!（縦横の分割数が共に2以上のときのみ）。
!
           if((nx>1).and.(ny>1)) then
            lkasyo=5+ny-1
           else
            lkasyo=5
           endif
!1/4点断面に一様な荷重を与えるのだけど、節点をn個の要素で
!共有している節点には n倍の節点力を与える。
!大きさ 1 の荷重をのべ何個の節点に振り分けるか：nf
             nf=4*nx*ny
             fn=float(nf)
!まず最初に、自由端の全ての節点に fy=2.d0/fn を与えてしまう。
!1箇所目の載荷箇所における載荷開始節点番号:lkais(1)
!断面の節点番号の一番若い節点（左上のかど）
            lkais(1)=(nx+1)*(ny+1)*(nz/2)+1
!1箇所目の載荷箇所における載荷終了節点番号:lryou(1)
            lryou(1)=(nx+1)*(ny+1)*(nz/2+1)
!tyoku.fでは載荷開始点から載荷終了点まで節点番号順に全て
!同じ載荷条件を与える。要素番号の順番は、最前面最上段左端の節点を
!1として、右(x)方向に進み、右端まできたらy方向へ1段下の段の左端から
!右へすすみ、真下の右端までいったら、z方向へ1面奥の面の左上から、
!また同じように1段づつ右へ進み、最下段の右端までいったら、もう一つ
!奥の面へと進んでいき、一番奥の面の最下段の右端が最終要素番号
!1箇所目の載荷箇所における載荷条件
!fx,fy,fz 方向のそれぞれに与える荷重
             fx2=0.d0
             fy2=2.d0/fn
             fz2=0.d0
!
             lkais(2)=lkais(1)
             lryou(2)=lkais(1)
             lkais(3)=lkais(2)+nx
             lryou(3)=lkais(3)
             lkais(4)=lkais(1)+(nx+1)*ny
             lryou(4)=lkais(4)
             lkais(5)=lryou(1)
             lryou(5)=lkais(5)
              fx1=0.d0
              fy1=1.d0/fn
              fz1=0.d0
c
!次に、自由端の周を除くすべての節点に fy=4.d0/fn を与えなおす。
           if((nx>1).and.(ny>1)) then
             do i=1,ny-1
               lkais(5+i)=lkais(1)+(nx+1)*i+1
               lryou(5+i)=lkais(1)+(nx+1)*i+nx-1
             end do
             fx4=0.d0
             fy4=4.d0/fn
             fz4=0.d0
            endif
!
!******* 材料定数 *********
!ヤング率：exx,eyy,ezz
            exx=2.d9
            eyy=2.d9
            ezz=2.d9
!ポアソン比：poixy,poixz,poiyz
            poixy=1.d0/3.d0
            poixz=1.d0/3.d0
            poiyz=1.d0/3.d0
!せん断弾性係数：gxy,gxz,gyz
            gxy=ezz/2.d0/(1.d0+poixy)
            gxz=gxy
            gyz=gxy
!
!aに柔性（コンプライアス）行列を入れる
            a(1,1)=1.d0/exx
            a(1,2)=-poixy/exx
            a(1,3)=-poixz/exx
            a(2,1)=a(1,2)
            a(2,2)=1.d0/eyy
            a(2,3)=-poiyz/eyy
            a(3,1)=a(1,3)
            a(3,2)=a(2,3)
            a(3,3)=1.d0/ezz
!
!荷重増分：df
            write(*,*) '荷重増分を入力して下さい'
            read(*,*) df
!荷重増分ステップ数：nstep
            write(*,*) '荷重増分ステップ数を入力して下さい'
            read(*,*) nstep
!
!***** 出力の設定 *****
!比較のために出力したい梁−柱理論値：nhikak
!nhikak=1: w 方向に引っ張った時の先端の伸びを出力
!nhikak=2: y 方向に曲げた時の先端のたわみを出力
!nhikak=3: x 方向に曲げた時の先端のたわみを出力
                  nhikak=3
!
!変位を画面出力したい節点の数：ngamen
!例えば、先端の節点すべてだったら：
            ngamen=(nx+1)*(ny+1)
!1つ目の出力したい節点番号：ngame1
            ngame1=(nx+1)*(ny+1)*nz+1
!
!変位をファイル出力したい節点の数：nfairu
            nfairu=1
!1つ目の出力したい節点番号：nfair1
            nfair1=(nx+1)*(ny+1)*(nz/2)
     &            +(nx+1)*(ny/2)
     &            +1
!
!
!
!tyokum.f 用の入力データを mage5p.d というファイルに出力する
!
         open(7,file='mage5p.d')
         write(7,500) yoko
         write(7,500) tate
         write(7,500) ziku
         write(7,1000) nx
         write(7,1000) ny
         write(7,1000) nz
         write(7,1000) kkasyo
         write(7,1000) kkais1
         write(7,1000) kryou1
         write(7,500) bu1
         write(7,500) bv1
         write(7,500) bw1
         write(7,1000) kkais2
         write(7,1000) kryou2
         write(7,500) bu2
         write(7,500) bv2
         write(7,500) bw2
         write(7,1000) kkais3
         write(7,1000) kryou3
         write(7,500) bu3
         write(7,500) bv3
         write(7,500) bw3
!端中央対称面の縦断面対称面(y軸)のx,z方向変位を固定
        do j=0,ny
         write(7,1000) (nx+1)*j+1
         write(7,1000) (nx+1)*j+1
         write(7,500) 0.d0
         write(7,500) 1.d0
         write(7,500) 0.d0
        end do
!縦断面対称面(yz面)のx方向変位を固定
        do k=1,nz
        do j=0,ny
         write(7,1000) (nx+1)*(ny+1)*k+(nx+1)*j+1
         write(7,1000) (nx+1)*(ny+1)*k+(nx+1)*j+1
         write(7,500) 0.d0
         write(7,500) 1.d0
         write(7,500) 1.d0
        end do
        end do
!端中央対称面の原点を固定
         write(7,1000) kkais3
         write(7,1000) kkais3
         write(7,500) 0.d0
         write(7,500) 0.d0
         write(7,500) 0.d0
!単純支持端面のz軸点のx,y方向変位を固定
         write(7,1000) kkais1
         write(7,1000) kkais1
         write(7,500) 0.d0
         write(7,500) 0.d0
         write(7,500) 1.d0
!
         write(7,1000) lkasyo
         write(7,1000) lkais(1)
         write(7,1000) lryou(1)
         write(7,500) fx2
         write(7,500) fy2
         write(7,500) fz2
         write(7,1000) lkais(2)
         write(7,1000) lryou(2)
         write(7,500) fx1
         write(7,500) fy1
         write(7,500) fz1
         write(7,1000) lkais(3)
         write(7,1000) lryou(3)
         write(7,500) fx1
         write(7,500) fy1
         write(7,500) fz1
         write(7,1000) lkais(4)
         write(7,1000) lryou(4)
         write(7,500) fx1
         write(7,500) fy1
         write(7,500) fz1
         write(7,1000) lkais(5)
         write(7,1000) lryou(5)
         write(7,500) fx1
         write(7,500) fy1
         write(7,500) fz1
          if((nx>1).and.(ny>1)) then
            do i=1,ny-1
         write(7,1000) lkais(5+i)
         write(7,1000) lryou(5+i)
         write(7,500) fx4
         write(7,500) fy4
         write(7,500) fz4
            end do
           endif
!
        do i=1,3
        do j=1,3
         write(7,900) a(i,j)
        end do
        end do
         write(7,500) gxy
         write(7,500) gxz
         write(7,500) gyz
         write(7,500) df
         write(7,1000) nhikak
!端部の図心変位のみを出す場合
         write(7,1000) nfairu
         write(7,1000) nfair1
!端部の全節点の変位を出す場合
!        write(7,1000) ngamen
!         do 21 i=lkais(1),lryou(1)
!          write(7,1000) i
c21        continue
         write(7,1000) nfairu
         write(7,1000) nfair1
         write(7,1000) nstep
          close(7)
!小数点以下5桁の実数
500      format(1pd13.5)
!小数点以下9桁の実数
900      format(1pd17.9)
!10桁までの整数
1000     format(i10)
         stop
         end
